"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createResponse = exports.generateContext = exports.getContext = void 0;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const getContext = (override) => Object.assign({
    payload: {
        action: '',
    },
    eventName: '',
    sha: '',
    ref: '',
    workflow: '',
    action: '',
    actor: '',
    issue: {
        owner: '',
        repo: '',
        number: 1,
    },
    repo: {
        owner: '',
        repo: '',
    },
    job: '',
    runNumber: 1,
    runId: 1,
    apiUrl: 'https://api.github.com',
    serverUrl: 'https://github.com',
    graphqlUrl: 'https://api.github.com/graphql',
}, override);
exports.getContext = getContext;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const generateContext = (settings, override) => {
    const overrideObj = override || {};
    return (0, exports.getContext)(Object.assign({}, {
        eventName: settings.event ? settings.event : '',
        ref: settings.ref ? settings.ref : '',
        sha: settings.sha ? settings.sha : '',
        action: settings.owner ? (settings.owner + '-generator') : '',
    }, overrideObj, {
        payload: Object.assign({
            action: settings.action ? settings.action : '',
        }, overrideObj['payload'] || {}),
        issue: Object.assign({
            owner: settings.owner ? settings.owner : '',
            repo: settings.repo ? settings.repo : '',
        }, overrideObj['issue'] || {}),
        repo: Object.assign({
            owner: settings.owner ? settings.owner : '',
            repo: settings.repo ? settings.repo : '',
        }, overrideObj['repo'] || {}),
    }));
};
exports.generateContext = generateContext;
const createResponse = (data, override = {}) => Object.assign({
    data,
    status: 0,
    url: 'https://example.com',
    headers: {
        date: '',
        'x-ratelimit-limit': '',
        'x-ratelimit-remaining': '',
        'x-ratelimit-reset': '',
        'x-Octokit-request-id': '',
        'x-Octokit-media-type': '',
        link: '',
        'last-modified': '',
        etag: '',
        status: '',
    },
    [Symbol.iterator]() {
        return {
            next() {
                return {
                    done: true,
                    value: true,
                };
            },
        };
    },
}, override);
exports.createResponse = createResponse;
